<?
class typo {

	
	public $nc_core;
	public $Catalogue_ID;
	public $Subdivision_ID;
	public $Sub_Class_ID;
	public $Class_ID;
	public $Message_ID;
	
	public function __construct () {
		$this->nc_core = nc_Core::get_object();
		$this->nc_core->event->bind($this, array('updateMessage' => '_updateMessage') );
		$this->nc_core->event->bind($this, array('addMessage' => '_addMessage') );
	}

	public function  _updateMessage($Catalogue_ID, $Subdivision_ID, $Sub_Class_ID, $Class_ID, $Message_ID) {
		
		$this->Catalogue_ID=$Catalogue_ID;
		$this->Subdivision_ID=$Subdivision_ID;
		$this->Sub_Class_ID=$Sub_Class_ID;
		$this->Class_ID=$Class_ID;
		$this->Message_ID=$Message_ID;
		
		$this->addAction('update');
	}
	public function  _addMessage($Catalogue_ID, $Subdivision_ID, $Sub_Class_ID, $Class_ID, $Message_ID) {
		
		$this->Catalogue_ID=$Catalogue_ID;
		$this->Subdivision_ID=$Subdivision_ID;
		$this->Sub_Class_ID=$Sub_Class_ID;
		$this->Class_ID=$Class_ID;
		$this->Message_ID=$Message_ID;
		
		$this->addAction('add');
	
		
	}
	
	function addAction($action){
	
		$res = $this->nc_core->db->get_results("SELECT Value FROM Settings WHERE `Key`='typetipograf'", ARRAY_A);
		$type_tip=$res[0]['Value'];
		
		$typo=$typo_1=false;
		$fields_typo_1=array();
		$fields_typo=array();
		
		
		//проверим есть ли тут текстовое поле
		$res = $this->nc_core->db->get_results("SELECT Field_Name,Field_ID,Format FROM Field WHERE Class_ID = ".$this->Class_ID." AND TypeOfData_ID=3 ", ARRAY_A);
		
		if ($res){
		
			foreach ($res as $val){
				if (strstr($val['Format'],"html:1;")){
					
					//разрешены теги
					$fields_typo[$val['Field_Name']]=$val['Field_Name'];
					
				}
				elseif(strstr($val['Format'],"html:0;")){
					
					//наследование
					$fields_typo_1[$val['Field_Name']]=$val['Field_Name'];
					
				}
			}
			
			//если есть поля с наследованием, проверим все уровни
			if (count($fields_typo_1)){
				
				//разрешены ли теги в Sub_Class
				$res = $this->nc_core->db->get_results("SELECT AllowTags FROM Sub_Class WHERE Sub_Class_ID = ".$this->Sub_Class_ID."", ARRAY_A);
				if ($res[0]['AllowTags']=='1'){
					//тут вызываем типографику
					$typo_1=true;
				}
				//тут если стоит наследование
				elseif ($res[0]['AllowTags']=='-1'){
					//тут проверяем глубже глубже проверяем в CLASS
					$res = $this->nc_core->db->get_results("SELECT AllowTags FROM Class WHERE Class_ID = ".$this->Class_ID."", ARRAY_A);
					if ($res[0]['AllowTags']=='1'){
						//тут вызываем типографику
						$typo_1=true;
					}
					
				}
			
			}
			
			
			if ($typo_1){
				foreach ($fields_typo_1 as $k=>$v)
				$fields_typo[$k]=$k;
				
			}
			
			

			if (count($fields_typo)){
				$res = $this->nc_core->db->get_results("SELECT ".implode(",",$fields_typo)." FROM Message".$this->Class_ID." WHERE Message_ID = ".$this->Message_ID."", ARRAY_A);
				if ($res){
					
					if ($type_tip=='artlebedev') {
						//настройки
						$remoteTypograf = new RemoteTypograf();
						$remoteTypograf->htmlEntities();
						$remoteTypograf->br (false);
						$remoteTypograf->p (true);
						$remoteTypograf->nobr (3);
						$remoteTypograf->quotA ('laquo raquo');
						$remoteTypograf->quotB ('bdquo ldquo');
					
					}
					else{
					
						//настройки
						$xml = '
							<?xml version="1.0" encoding="windows-1251" ?>
							<preferences>
								<!-- Теги -->
								<tags delete="0">0</tags>
								<!-- Абзацы -->
								<paragraph insert="0">
									<start><![CDATA[<p>]]></start>
									<end><![CDATA[</p>]]></end>
								</paragraph>
								<!-- Переводы строк -->
								<newline insert="0"><![CDATA[<br />]]></newline>
								<!-- Переводы строк <p>&nbsp;</p> -->
								<cmsNewLine valid="0" />
								<!-- DOS текст -->
								<dos-text delete="0" />
								<!-- Неразрывные конструкции -->
								<nowraped insert="1" nonbsp="0" length="0">
									<start><![CDATA[<nobr>]]></start>
									<end><![CDATA[</nobr>]]></end>
								</nowraped>
								<!-- Висячая пунктуация -->
								<hanging-punct insert="0" />
								<!-- Удалять висячие слова -->
								<hanging-line delete="0" />
								<!-- Символ минус -->
								<minus-sign><![CDATA[&ndash;]]></minus-sign>
								<!-- Переносы -->
								<hyphen insert="0" length="0" />
								<!-- Акронимы -->
								<acronym insert="1"></acronym>
								<!-- Вывод символов 0 - буквами 1 - числами -->
								<symbols type="0" />
								<!-- Параметры ссылок -->
								<link target="" class="" />
								chr=UTF-8 
							</preferences>
							';
						
					
					}
				
					foreach ($res as $val){
						foreach ($fields_typo as $field){
						
							$text='';
							
							if ($type_tip=='artlebedev')
								$text=$remoteTypograf->processText ($val[$field]);
							else
								$text=$this->post('www.typograf.ru','/webservice/','text='.urlencode($val[$field]).'&chr=UTF-8&xml='.urlencode($xml));
							
							if ($text)
								$this->nc_core->db->query("UPDATE Message".$this->Class_ID." SET ".$field."='".mysql_real_escape_string($text)."' WHERE Message_ID = ".$this->Message_ID."");
							
							
							
						}
					}
				}
			}
			
			
			
		}
		else{
			
			//уходим или точнее ничего не делаем
			return;
		}
		
		
		
	}
	
	function post($host,$script,$data){ 
		
	
		$fp = fsockopen($host,80,$errno, $errstr, 30 );  
		stream_set_timeout($fp,1,5000);
		if ($fp) { 
			fputs($fp, "POST $script HTTP/1.1\n");  
			fputs($fp, "Host: $host\n");  
			fputs($fp, "Content-type: application/x-www-form-urlencoded\n");  
			fputs($fp, "Content-length: " . strlen($data) . "\n");
			fputs($fp, "User-Agent: PHP Script\n");  
			fputs($fp, "Connection: close\n\n");  
			fputs($fp, $data);  
			while(fgets($fp,2048) != "\r\n" && !feof($fp));
			unset($buf);
			while(!feof($fp)) $buf .= fread($fp,2048);
			fclose($fp); 
		}
		else{ 
			return false; 
		}
		return $buf; 
	}

	
	
}

class RemoteTypograf
{
	var $_entityType = 4;
	var $_useBr = 1;
	var $_useP = 1;
	var $_maxNobr = 3;
	var $_encoding = 'UTF-8';
	var $_quotA = 'laquo raquo';
	var $_quotB = 'bdquo ldquo';

	function RemoteTypograf ($encoding)
	{
		if ($encoding) $this->_encoding = $encoding;
	}

	function htmlEntities()
	{
		$this->_entityType = 1;
	}

	function xmlEntities()
	{
		$this->_entityType = 2;
	}

	function mixedEntities()
	{
		$this->_entityType = 4;
	}

	function noEntities()
	{
		$this->_entityType = 3;
	}

	function br ($value)
	{
		$this->_useBr = $value ? 1 : 0;
	}
	
	function p ($value)
	{
		$this->_useP = $value ? 1 : 0;
	}
	
	function nobr ($value)
	{
		$this->_maxNobr = $value ? $value : 0;
	}

	function quotA ($value)
	{
		$this->_quotA = $value;
	}
	
	function quotB ($value)
	{
		$this->_quotB = $value;
	}

	function processText ($text)
	{
		$text = str_replace ('&', '&amp;', $text);
		$text = str_replace ('<', '&lt;', $text);
		$text = str_replace ('>', '&gt;', $text);

		$SOAPBody = '<?xml version="1.0" encoding="' . $this->_encoding . '"?>
<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
  <soap:Body>
	<ProcessText xmlns="http://typograf.artlebedev.ru/webservices/">
	  <text>' . $text . '</text>
      <entityType>' . $this->_entityType . '</entityType>
      <useBr>' . $this->_useBr . '</useBr>
      <useP>' . $this->_useP . '</useP>
      <maxNobr>' . $this->_maxNobr . '</maxNobr>
      <quotA>' . $this->_quotA . '</quotA>
      <quotB>' . $this->_quotB . '</quotB>
	</ProcessText>
  </soap:Body>
</soap:Envelope>';

		$host = 'typograf.artlebedev.ru';
		$SOAPRequest = 'POST /webservices/typograf.asmx HTTP/1.1
Host: typograf.artlebedev.ru
Content-Type: text/xml
Content-Length: ' . strlen ($SOAPBody). '
SOAPAction: "http://typograf.artlebedev.ru/webservices/ProcessText"

'.
	$SOAPBody;

		$remoteTypograf = fsockopen ($host, 80);
		fwrite ($remoteTypograf, $SOAPRequest);
		$typografResponse = '';
		while (!feof ($remoteTypograf))
		{
			$typografResponse .= fread ($remoteTypograf, 8192);
		}
		fclose ($remoteTypograf);
		
		$startsAt = strpos ($typografResponse, '<ProcessTextResult>') + 19;
		$endsAt = strpos ($typografResponse, '</ProcessTextResult>');
		$typografResponse = substr ($typografResponse, $startsAt, $endsAt - $startsAt - 1);
		
		$typografResponse = str_replace ('&amp;', '&', $typografResponse);
		$typografResponse = str_replace ('&lt;', '<', $typografResponse);
		$typografResponse = str_replace ('&gt;', '>', $typografResponse);

		return  $typografResponse;
	}
}

$typo = new  typo();
//$listenObj->_updateMessage();

?>